(function ($, Drupal) {

  Drupal.behaviors.improvementsForm = {
    attach: function attach(context, settings) {
      if (context.tagName == 'SCRIPT') {
        return;
      }

      // Trigger "delayedinput" event after user change input
      once('delayedinput', 'input[type="text"], input[type="number"], input[type="email"], textarea', context).forEach(function (element) {
        var $input = $(element);
        var timeout = $input.data('input-timeout') ? $input.data('input-timeout') : 500;
        var timer;

        var trigger = function () {
          $input.trigger('delayedinput');
          timer = null;
        };

        $input.on('input', function (event) {
          clearTimeout(timer);
          timer = setTimeout(trigger, timeout);
        });

        $input.on('blur', function (event) {
          if (timer) {
            clearTimeout(timer);
            trigger();
          }
        });

      });
    }
  };

})(jQuery, Drupal);
