(function ($, Drupal) {

  Drupal.behaviors.improvementsSpinner = {
    attach: function (context, settings) {
      if (context.tagName == 'SCRIPT') {
        return;
      }

      // Init jQuery UI Spinner widget
      // Used each() because Drupal.debounce() needs separate instance on each spinner.
      $('input.form-spinner:not(.ui-spinner-input)', context).each(function () {
        $(this).spinner({
          // Trigger "input" event when spinner changed
          // Used "spin" event because "stop" event triggered when element losing focus.
          spin: function () {
            $(this).trigger('input');
          },
          icons: {
            up: '',
            down: '',
          },
          classes: {
            'ui-spinner': '',
            'ui-spinner-down': '',
            'ui-spinner-up': '',
          },
        });
      });
    }
  };

})(jQuery, Drupal);
