<?php

namespace Drupal\improvements\Plugin\ExtraField\Display;

use Drupal\Core\Entity\ContentEntityInterface;
use Drupal\extra_field_plus\Plugin\ExtraFieldPlusDisplayFormattedBase;

/**
 * @ExtraFieldDisplay(
 *   id = "read_more_link",
 *   label = @Translation("Read More link"),
 *   bundles = {
 *     "node.*",
 *     "taxonomy_term.*",
 *   },
 *   visible = false,
 * )
 */
class ReadMoreLink extends ExtraFieldPlusDisplayFormattedBase {

  /**
   * {@inheritdoc}
   */
  public function defaultFormValues(): array {
    $values = parent::defaultFormValues();

    $values += [
      'text' => $this->t('Read more'),
    ];

    return $values;
  }

  /**
   * {@inheritdoc}
   */
  public function settingsForm(): array {
    $form = parent::settingsForm();

    $form['text'] = [
      '#type' => 'textfield',
      '#title' => $this->t('Link text'),
    ];

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function viewElements(ContentEntityInterface $entity): array {
    $formatter_settings = $this->getSettings();

    return [
      '#type' => 'link',
      '#title' => $formatter_settings['text'],
      '#url' => $entity->toUrl(),
    ];
  }

}
